/*
 * Copyright (C) 2018 Robert Bosch GmbH Copyright (C) 2018 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.
 */

import 'jest-preset-angular/setup-jest';
import 'mutationobserver-shim';

Object.defineProperty(window, 'matchMedia', {
  writable: true,
  value: jest.fn().mockImplementation((query) => ({
    matches: false,
    media: query,
    onchange: null,
    addListener: jest.fn(), // deprecated
    removeListener: jest.fn(), // deprecated
    addEventListener: jest.fn(),
    removeEventListener: jest.fn(),
    dispatchEvent: jest.fn(),
  })),
});

export function expectValues<T>(values: T[], done: () => any) {
  let emissions = 0;
  return (value: T) => {
    expect(value).toEqual(values[emissions++]);
    if (emissions === values.length) {
      done();
    }
  };
}
